//+------------------------------------------------------------------+
//|                                                      ILRS_MA.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2



extern int                Length = 20;
extern ENUM_APPLIED_PRICE Price  = 0;      

double ILRS[];
double Pr[];
double buffer2[];
double buffer3[];
double trend[];

double sum, sum2;

int init()
{
 IndicatorBuffers(5);
 SetIndexBuffer(0,ILRS);
 SetIndexBuffer(1,buffer2);
 SetIndexBuffer(2,buffer3);
 SetIndexBuffer(3,Pr);
 SetIndexBuffer(4,trend);
 sum=Length*(Length-1)/2;
 sum2=(Length-1)*Length*(2*Length-1)/6; 
 IndicatorShortName("Integral of Linear Regression Slope Moving Average");
return(0);
}

int deinit()
{

 return(0);
}

//
//
//
//
//

int start()
{
    int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
    //
    //
    //
    //
    //
    
    if (trend[limit]==-1) CleanPoint(limit,buffer2,buffer3);
    for(int i=limit; i>=0; i--)
    {
       Pr[i]=iMA(NULL, 0, 1, 0, MODE_SMA, Price, i);
 
       double sum1=0; double sumy=0; for (int k=0;k<Length;k++){ sum1+=Pr[i+k]*k; sumy+=Pr[i+k]; }
       double num1=sum1*Length-sum*sumy;
       double num2=sum*sum-sum2*Length;
       double slope;
       if (num2!=0) {  slope=num1/num2;  }
       else         {  slope=0;          }
       ILRS[i]=iMA(NULL,0,Length,0,MODE_SMA,Price,i)+slope;
       
       //
       //
       //
       //
       //
       
       buffer2[i] = EMPTY_VALUE;
       buffer3[i] = EMPTY_VALUE;
       trend[i]   = trend[i+1];
       if (ILRS[i]>ILRS[i+1]) trend[i] = 1;
       if (ILRS[i]<ILRS[i+1]) trend[i] =-1;
       if (trend[i]==-1) PlotPoint(i,buffer2,buffer3,ILRS);
    }  
 
 return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}


